## qubes-gui-daemon 4.2.6

=== debian/changelog ===
qubes-gui-daemon (4.2.6-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Fri, 05 Apr 2024 19:05:53 +0200

qubes-gui-daemon (4.2.6-1) unstable; urgency=medium

  [ Demi Marie Obenour ]
  * Clean up do_shm_update

  [ Marek Marczykowski-Górecki ]
  * pulse: add timestamps to log output
  * pulse: add opt-in debug logging
  * pulse: make tlength parameter configurable, reduce fragsize

  [ Demi Marie Obenour ]
  * Allow periods in qube names

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 05 Apr 2024 19:05:53 +0200

## qubes-gui-daemon 4.2.7

=== debian/changelog ===
qubes-gui-daemon (4.2.7-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Sun, 28 Apr 2024 03:19:03 +0200

qubes-gui-daemon (4.2.7-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * pacat-simple-vchan: reconnect on vchan eof
  * pacat-simple-vchan: improve cleanup

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 28 Apr 2024 03:19:03 +0200

## qubes-gui-daemon 4.2.8

=== debian/changelog ===
qubes-gui-daemon (4.2.8-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Mon, 17 Jun 2024 04:29:18 +0200

qubes-gui-daemon (4.2.8-1) unstable; urgency=medium

  * Add basic SELinux policy

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 17 Jun 2024 04:29:18 +0200

## qubes-gui-daemon 4.2.9

=== Makefile ===
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

MANDIR ?= /usr/share/man
LIBDIR ?= /usr/lib64
VCHAN_PKG ?= vchan-xen
export LIBDIR CFLAGS

help:
	@echo "Qubes GUI main Makefile:" ;\
	    echo "make all                  <--- build binaries";\
	    echo "make install              <--- install files into \$$DESTDIR";\
	    echo "make clean                <--- clean all the binary files";\
	    exit 0;

selinux_policies ::= qubes-gui-daemon.pp

all_targets := gui-daemon/qubes-guid gui-daemon/qubes-guid.1 \
     shmoverride/shmoverride.so \
     shmoverride/X-wrapper-qubes pulse/pacat-simple-vchan \
     screen-layout-handler/watch-screen-layout-changes


all: $(all_targets)
all-selinux: selinux/$(selinux_policies)
.PHONY: $(all_targets) all-selinux install tar clean help

gui-daemon/qubes-guid gui-daemon/qubes-guid.1:
	$(MAKE) -C gui-daemon qubes-guid qubes-guid.1

shmoverride/shmoverride.so:
	(cd shmoverride; $(MAKE) shmoverride.so)

shmoverride/X-wrapper-qubes:
	(cd shmoverride; $(MAKE) X-wrapper-qubes)
	
pulse/pacat-simple-vchan:
	$(MAKE) -C pulse pacat-simple-vchan

screen-layout-handler/watch-screen-layout-changes:
	$(MAKE) -C screen-layout-handler watch-screen-layout-changes

selinux/$(selinux_policies):
	$(MAKE) -C selinux -f /usr/share/selinux/devel/Makefile

install:
	install -D gui-daemon/qubes-guid $(DESTDIR)/usr/bin/qubes-guid
	install -m 0644 -D gui-daemon/qubes-guid.1 $(DESTDIR)$(MANDIR)/man1/qubes-guid.1
	install -D pulse/pacat-simple-vchan $(DESTDIR)/usr/bin/pacat-simple-vchan
	install -D pulse/qubes.AudioInputEnable $(DESTDIR)/etc/qubes-rpc/qubes.AudioInputEnable
	install -D pulse/qubes.AudioInputDisable $(DESTDIR)/etc/qubes-rpc/qubes.AudioInputDisable
	install -D shmoverride/X-wrapper-qubes $(DESTDIR)/usr/bin/X-wrapper-qubes
	install -D shmoverride/shmoverride.so $(DESTDIR)$(LIBDIR)/qubes-gui-daemon/shmoverride.so
	install -D -m 0644 gui-daemon/guid.conf $(DESTDIR)/etc/qubes/guid.conf
	install -D gui-daemon/qubes-localgroup.sh $(DESTDIR)/etc/X11/xinit/xinitrc.d/qubes-localgroup.sh
	install -D -m 0644 common/90-default-gui-daemon.policy $(DESTDIR)/etc/qubes/policy.d/90-default-gui-daemon.policy
	install -D screen-layout-handler/watch-screen-layout-changes $(DESTDIR)/usr/libexec/qubes/watch-screen-layout-changes
	install -D -m 0644 screen-layout-handler/qubes-screen-layout-watches.desktop $(DESTDIR)/etc/xdg/autostart/qubes-screen-layout-watches.desktop
	$(MAKE) -C window-icon-updater install

install-selinux:
	install -D -t $(DESTDIR)/usr/share/selinux/packages selinux/$(selinux_policies)

tar:
	git archive --format=tar --prefix=qubes-gui/ HEAD -o qubes-gui.tar

clean:
	(cd common; $(MAKE) clean)
	(cd gui-common; $(MAKE) clean)
	(cd gui-daemon; $(MAKE) clean)
	(cd shmoverride; $(MAKE) clean)
	$(MAKE) -C pulse clean

.PHONY: all clean tar install help

=== pulse/Makefile ===
VCHAN_PKG = $(if $(BACKEND_VMM),vchan-$(BACKEND_VMM),vchan)
CC ?= gcc
CFLAGS += -Wall -Wextra -Werror -g -O2 -fPIC -fcf-protection -fstack-clash-protection -D_GNU_SOURCE=
VCHANLIBS=`pkg-config --libs $(VCHAN_PKG)`
VCHANCFLAGS=`pkg-config --cflags $(VCHAN_PKG)`
GLIBCFLAGS=`pkg-config --cflags glib-2.0`
GLIBLIBS=`pkg-config --libs glib-2.0`
all: pacat-simple-vchan
pacat-simple-vchan.o: pacat-simple-vchan.c
	$(CC) $(CFLAGS) -c $(VCHANCFLAGS) -I. $(GLIBCFLAGS) pacat-simple-vchan.c
pacat-simple-vchan: pacat-simple-vchan.o
	$(CC) -o pacat-simple-vchan $^ \
		$(VCHANLIBS) -lpulse -lpulse-mainloop-glib -lqubesdb $(GLIBLIBS)
clean:
	rm -f ./*~ ./*.o ./*.so ./pacat-simple-vchan
.PHONY: clean all

=== screen-layout-handler/Makefile ===
LDLIBS=-lX11 -lXrandr

all: watch-screen-layout-changes

=== debian/changelog ===
qubes-gui-daemon (4.2.9-1+deb13u1) trixie; urgency=medium

  * Build for trixie

 -- Builder <user@localhost>  Mon, 03 Mar 2025 14:39:48 +0100

qubes-gui-daemon (4.2.9-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Leave defining _FORTIFY_SOURCE to distribution policy
  * shmoverride: do not remove the shmid file if taking the lock fails

  [ qubest ]
  * remove trailing x00 The trailing x00 in the request header make the
    domain name as follow (domainx00). Which cause a bug when listing
    domains using qubesadminapi. This bug occured when the icon-receiver
    is running on guivm other than dom0.
  * Move rstrip before split
  * change restrip to rstrip

  [ Aaron Rainbolt ]
  * Typo fix, change "canot" to "cannot"

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 03 Mar 2025 14:39:48 +0100

## qubes-gui-daemon 4.3.0

=== debian/changelog ===
qubes-gui-daemon (4.3.0-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Sat, 15 Jun 2024 21:34:13 +0200

qubes-gui-daemon (4.3.0-1) unstable; urgency=medium

  [ Piotr Bartman ]
  * q-dev: reformat file + typos
  * q-dev: change `devclass` to be consistent with qubes-core-admin
  * q-dev: set Microphone Interface
  * q-dev: device protocol
  * q-dev: fix device protocol
  * q-dev: better description of mic

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 15 Jun 2024 21:34:13 +0200

=== debian/control ===
Source: qubes-gui-daemon
Section: admin
Priority: optional
Maintainer: Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>
Build-Depends:
 debhelper (>= 10),
 qubes-gui-common,
 config-package-dev,
 libxen-dev,
 libvchan-xen-dev,
 python3-dev,
 libpulse-dev,
 libxrandr-dev,
 libxcb1-dev,
 libxcb-util0-dev,
 libxcb-shm0-dev,
 libx11-xcb-dev,
 libconfig-dev,
 libpng-dev,
 libnotify-dev,
 qubesdb-dev,
 help2man,
 libqubes-pure-dev,
Standards-Version: 4.1.3
Homepage: https://qubes-os.org/
Vcs-Browser: https://github.com/QubesOS/qubes-gui-daemon
Vcs-Git: https://github.com/QubesOS/qubes-gui-daemon.git

Package: qubes-gui-daemon
Architecture: any
Depends:
 python3-xcffib,
 xserver-xorg-core,
 python3,
 qubes-core-qrexec (>= 4.1.5),
 python3-qubesimgconverter (>= 4.1.4),
 socat,
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 qubes-audio-daemon
Provides: ${diverted-files}
Conflicts: ${diverted-files}
Description: Qubes GUI virtualization (GUI VM side)
 The Qubes GUI virtualization infrastructure that needs to be installed in GUI
 VM.

Package: qubes-audio-daemon
Architecture: any
Depends:
 pulseaudio,
 ${shlibs:Depends},
 ${misc:Depends}
Replaces: qubes-gui-daemon-pulseaudio (<< 4.1.21~)
Breaks: qubes-gui-daemon-pulseaudio (<< 4.1.21~)
Description: Qubes audio virtualization (GUI/Audio VM side)
 The GUI/Audio VM side of Qubes audio virtualization.

Package: qubes-gui-daemon-pulseaudio
Architecture: any
Depends:
 qubes-audio-daemon,
 ${misc:Depends}
Description: transitional package
 This is a transitional package. It can safely be removed.

## qubes-gui-daemon 4.3.1

=== gui-daemon/Makefile ===
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

MAKEFLAGS := -rR
VCHAN_PKG = $(if $(BACKEND_VMM),vchan-$(BACKEND_VMM),vchan)
CC=gcc
pkgs := x11 x11-xcb xcb xcb-shm xcb-aux glib-2.0 $(VCHAN_PKG) libpng libnotify libconfig
objs := xside.o png.o trayicon.o ../gui-common/double-buffer.o ../gui-common/txrx-vchan.o \
	../gui-common/error.o list.o
extra_cflags := -I../include/ -g -O2 -Wall -Wextra -Werror -pie -fPIC \
		$(shell pkg-config --cflags $(pkgs)) \
		-fvisibility=hidden \
		-fno-strict-aliasing \
		-fno-strict-overflow \
		-fno-delete-null-pointer-checks \
		-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GNU_SOURCE -Werror=missing-prototypes

LDLIBS := $(shell pkg-config --libs $(pkgs)) -lqubes-pure
all: qubes-guid # qubes-guid.1
vpath %.c ../common
qubes-guid: $(objs)
	$(CC) -g -pie -o qubes-guid $(objs) -Wall -lm $(LDLIBS) $(LDFLAGS) -Wl,-Bsymbolic

qubes-guid.1: qubes-guid
	LC_ALL=C help2man --version-string=`cat ../version` --no-info --name="Qubes GUI daemon" ./qubes-guid  > qubes-guid.1

clean:
	rm -f qubes-guid ./*.o ./*~

%.o: %.c Makefile
	$(CC) -MD -MP -MF $@.dep -c -o $@ $(extra_cflags) $(CFLAGS) $<
-include *.dep

=== pulse/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 VCHAN_PKG = $(if $(BACKEND_VMM),vchan-$(BACKEND_VMM),vchan)
 CC ?= gcc
-CFLAGS += -Wall -Wextra -Werror -g -O2 -fPIC -fcf-protection -fstack-clash-protection -D_GNU_SOURCE=
+CFLAGS += -Wall -Wextra -Werror -g -O2 -fPIC -D_FORTIFY_SOURCE=2 -fcf-protection -fstack-clash-protection -D_GNU_SOURCE=
 VCHANLIBS=`pkg-config --libs $(VCHAN_PKG)`
 VCHANCFLAGS=`pkg-config --cflags $(VCHAN_PKG)`
 GLIBCFLAGS=`pkg-config --cflags glib-2.0`

=== shmoverride/Makefile ===
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

BACKEND_VMM_PKGCONFIG = $(shell pkg-config --variable=backend_vmm vchan)
BACKEND_VMM ?= $(firstword $(BACKEND_VMM_PKGCONFIG) xen)
ifneq ($(BACKEND_VMM),xen)
$(error shmoverride currently supports Xen only, '$(BACKEND_VMM)' set)
endif

LIBDIR ?= /usr/lib64
extra_cflags := -g -O2 -I../include/ -fPIC -Wall -Wextra -Werror \
		-DBACKEND_VMM_$(BACKEND_VMM) \
		-DSHMOVERRIDE_LIB_PATH=\"$(LIBDIR)/qubes-gui-daemon/shmoverride.so\" \
		-I../include -fvisibility=hidden -pthread
CC=gcc

all: shmoverride.so X-wrapper-qubes

shmoverride.so: shmoverride.o ./list.o
	$(CC) $(CFLAGS) $(extra_cflags) -shared -o shmoverride.so \
		shmoverride.o list.o -ldl -lxenctrl -lxengnttab -Wl,-Bsymbolic

vpath %.c ../common

X-wrapper-qubes: X-wrapper-qubes.o

clean:
	rm -f ./*~ ./*.o shmoverride.so X-wrapper-qubes

%.o: %.c Makefile
	$(CC) -MD -MP -MF $@.dep -c -o $@ $(extra_cflags) $(CFLAGS) $<
-include *.dep

=== window-icon-updater/Makefile ===
all:
	@true

install:
	install -D icon-receiver $(DESTDIR)/usr/lib/qubes/icon-receiver
	ln -s /var/run/qubes/icon-receiver.sock $(DESTDIR)/etc/qubes-rpc/qubes.WindowIconUpdater
	install -d $(DESTDIR)/etc/qubes/rpc-config
	install -m 0664 -D qubes.WindowIconUpdater.config $(DESTDIR)/etc/qubes/rpc-config/qubes.WindowIconUpdater
	install -m 0664 -D qubes-icon-receiver.desktop $(DESTDIR)/etc/xdg/autostart/qubes-icon-receiver.desktop

## qubes-gui-daemon 4.3.3

=== debian/changelog ===
qubes-gui-daemon (4.3.3-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Mon, 12 Aug 2024 17:11:04 +0200

qubes-gui-daemon (4.3.3-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * Update lint job
  * Use QubesDB to authorize usage of mic and retrieve its status

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 12 Aug 2024 17:11:04 +0200

qubes-gui-daemon (4.3.2-1) unstable; urgency=medium

  [ Euwiiwueir ]
  * Factor out a function to parse color from string
  * qubes-guid: add window_background_color setting

  [ Frédéric Pierret (fepitre) ]
  * Reformat according to python-black

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 05 Jul 2024 17:28:35 +0200

qubes-gui-daemon (4.3.1-1) unstable; urgency=medium

  * Add basic SELinux policy

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 17 Jun 2024 04:27:04 +0200

## qubes-gui-daemon 4.3.4

=== debian/changelog ===
qubes-gui-daemon (4.3.4-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Sun, 27 Oct 2024 03:28:47 +0100

qubes-gui-daemon (4.3.4-1) unstable; urgency=medium

  [ Yaroslav Bolyukin ]
  * fix: shmoverride hooks in presence of other constructors calling
    fstat

  [ Marek Marczykowski-Górecki ]
  * Add Xwayland wrapper similar to the one for Xorg
  * shmoverride: do not remove the shmid file if taking the lock fails
  * CI: switch to R4.3

  [ Ali Mirjamali ]
  * Make maximum clipboard buffer lenght configurable
  * Switching CI to R4.3
  * Improve clipboard .metadata parsing

  [ Marek Marczykowski-Górecki ]
  * Bump required qubes-gui-common version

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 27 Oct 2024 03:28:47 +0100

## qubes-gui-daemon 4.3.5

=== debian/changelog ===
qubes-gui-daemon (4.3.5-1+jammy1) jammy; urgency=medium

  * Build for jammy

 -- Builder <user@localhost>  Sun, 17 Nov 2024 03:56:10 +0100

qubes-gui-daemon (4.3.5-1) unstable; urgency=medium

  [ Piotr Bartman-Szwarc ]
  * q-dev: port
  * q-dev: cleanup
  * q-dev: lint
  * q-dev: update argument name ident -> port_id
  * q-dev: update argument name device -> port
  * q-dev: add less confusing device_id of microphone
  * q-dev: mic auto-attach
  * q-dev: cleanup mic.py

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 17 Nov 2024 03:56:10 +0100

## qubes-gui-daemon 4.3.6

=== debian/changelog ===
qubes-gui-daemon (4.3.6-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Fri, 29 Nov 2024 04:02:02 +0100

qubes-gui-daemon (4.3.6-1) unstable; urgency=medium

  [ Aaron Rainbolt ]
  * Typo fix, change "canot" to "cannot"
  * Replace magic quotes with normal quotes in parse_vm_config
  * Add event buffering for cloaking user input patterns

  [ Ali Mirjamali ]
  * Handle `disable` & `none` for secure copy/paste
  * Add `_NET_WM_PING` support
  * Add `_NET_WM_NAME` & `_NET_WM_ICON_NAME` support

  [ qubest ]
  * Update guivm service name
  * remove trailing x00 The trailing x00 in the request header make the
    domain name as follow (domainx00). Which cause a bug when listing
    domains using qubesadminapi. This bug occured when the icon-receiver
    is running on guivm other than dom0.
  * Move rstrip before split
  * change restrip to rstrip

  [ Marek Marczykowski-Górecki ]
  * Leave defining _FORTIFY_SOURCE to distribution policy

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 29 Nov 2024 04:02:02 +0100

## qubes-gui-daemon 4.3.7

=== Makefile ===
--- 
+++ 
@@ -35,7 +35,9 @@
 
 all_targets := gui-daemon/qubes-guid gui-daemon/qubes-guid.1 \
      shmoverride/shmoverride.so \
-     shmoverride/X-wrapper-qubes pulse/pacat-simple-vchan \
+     shmoverride/X-wrapper-qubes \
+	 shmoverride/Xwayland-wrapper \
+	 pulse/pacat-simple-vchan \
      screen-layout-handler/watch-screen-layout-changes
 
 
@@ -51,7 +53,10 @@
 
 shmoverride/X-wrapper-qubes:
 	(cd shmoverride; $(MAKE) X-wrapper-qubes)
-	
+
+shmoverride/Xwayland-wrapper:
+	(cd shmoverride; $(MAKE) Xwayland-wrapper)
+
 pulse/pacat-simple-vchan:
 	$(MAKE) -C pulse pacat-simple-vchan
 
@@ -65,10 +70,9 @@
 	install -D gui-daemon/qubes-guid $(DESTDIR)/usr/bin/qubes-guid
 	install -m 0644 -D gui-daemon/qubes-guid.1 $(DESTDIR)$(MANDIR)/man1/qubes-guid.1
 	install -D pulse/pacat-simple-vchan $(DESTDIR)/usr/bin/pacat-simple-vchan
-	install -D pulse/qubes.AudioInputEnable $(DESTDIR)/etc/qubes-rpc/qubes.AudioInputEnable
-	install -D pulse/qubes.AudioInputDisable $(DESTDIR)/etc/qubes-rpc/qubes.AudioInputDisable
 	install -D shmoverride/X-wrapper-qubes $(DESTDIR)/usr/bin/X-wrapper-qubes
 	install -D shmoverride/shmoverride.so $(DESTDIR)$(LIBDIR)/qubes-gui-daemon/shmoverride.so
+	install -D shmoverride/Xwayland-wrapper $(DESTDIR)/usr/libexec/qubes/wrappers/Xwayland
 	install -D -m 0644 gui-daemon/guid.conf $(DESTDIR)/etc/qubes/guid.conf
 	install -D gui-daemon/qubes-localgroup.sh $(DESTDIR)/etc/X11/xinit/xinitrc.d/qubes-localgroup.sh
 	install -D -m 0644 common/90-default-gui-daemon.policy $(DESTDIR)/etc/qubes/policy.d/90-default-gui-daemon.policy

=== common/Makefile ===
all:
	@echo Doing nothing.
clean:
	rm -f *.o

=== debian/changelog ===
qubes-gui-daemon (4.3.7-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Tue, 10 Dec 2024 19:29:44 +0100

qubes-gui-daemon (4.3.7-1) unstable; urgency=medium

  * audio: fix reacting on mic enable/disable requests

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 10 Dec 2024 19:29:44 +0100

## qubes-gui-daemon 4.3.8

=== debian/changelog ===
qubes-gui-daemon (4.3.8-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Mon, 17 Mar 2025 03:49:55 +0100

qubes-gui-daemon (4.3.8-1) unstable; urgency=medium

  [ Ali Mirjamali ]
  * Fix clipboard paste metadata for qrexec (Windows)

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 17 Mar 2025 03:49:55 +0100

## qubes-gui-daemon 4.3.9

=== debian/changelog ===
qubes-gui-daemon (4.3.9-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Tue, 10 Jun 2025 04:23:06 +0200

qubes-gui-daemon (4.3.9-1) unstable; urgency=medium

  [ Ali Mirjamali ]
  * Replace U+2026 with `...` if utf8 is disabled
  * Assure Popup Windows (override-redirect) open over parent

  [ Marek Marczykowski-Górecki ]
  * Cache window name length when checking for truncated string

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 10 Jun 2025 04:23:06 +0200

## qubes-gui-daemon 4.3.10

=== debian/changelog ===
qubes-gui-daemon (4.3.10-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Thu, 26 Jun 2025 18:20:06 +0200

qubes-gui-daemon (4.3.10-1) unstable; urgency=medium

  * pulse: connect recording stream only when recording is allowed

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 26 Jun 2025 18:20:06 +0200

## qubes-gui-daemon 4.3.11

=== debian/changelog ===
qubes-gui-daemon (4.3.11-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Thu, 07 Aug 2025 02:15:05 +0200

qubes-gui-daemon (4.3.11-1) unstable; urgency=medium

  [ Ali Mirjamali ]
  * Notify users on clipboard paste denied by policies

  [ 3np ]
  * debian: Support pipewire-pulseaudio as well as pulseaudio

  [ Marek Marczykowski-Górecki ]
  * debian: fix installing qubes-guid as suid

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 07 Aug 2025 02:15:05 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>
 Build-Depends:
  debhelper (>= 10),
- qubes-gui-common,
+ qubes-gui-common (>= 4.3.0),
  config-package-dev,
  libxen-dev,
  libvchan-xen-dev,
@@ -48,7 +48,7 @@
 Package: qubes-audio-daemon
 Architecture: any
 Depends:
- pulseaudio,
+ pulseaudio | pipewire-pulse,
  ${shlibs:Depends},
  ${misc:Depends}
 Replaces: qubes-gui-daemon-pulseaudio (<< 4.1.21~)

## qubes-gui-daemon 4.3.12

=== debian/changelog ===
qubes-gui-daemon (4.3.12-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Fri, 08 Aug 2025 01:47:46 +0200

qubes-gui-daemon (4.3.12-1) unstable; urgency=medium

  * Pull in notification proxy together with gui daemon

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 08 Aug 2025 01:47:46 +0200

## qubes-gui-daemon 4.3.13

=== gui-daemon/Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 		-fno-strict-aliasing \
 		-fno-strict-overflow \
 		-fno-delete-null-pointer-checks \
-		-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GNU_SOURCE -Werror=missing-prototypes
+		-Wp,-D_GNU_SOURCE -Werror=missing-prototypes
 
 LDLIBS := $(shell pkg-config --libs $(pkgs)) -lqubes-pure
 all: qubes-guid # qubes-guid.1

=== shmoverride/Makefile ===
--- 
+++ 
@@ -33,7 +33,7 @@
 		-I../include -fvisibility=hidden -pthread
 CC=gcc
 
-all: shmoverride.so X-wrapper-qubes
+all: shmoverride.so X-wrapper-qubes Xwayland-wrapper
 
 shmoverride.so: shmoverride.o ./list.o
 	$(CC) $(CFLAGS) $(extra_cflags) -shared -o shmoverride.so \
@@ -43,8 +43,11 @@
 
 X-wrapper-qubes: X-wrapper-qubes.o
 
+Xwayland-wrapper: Xwayland-wrapper.in
+	sed -e "s,@SHMOVERRIDE_LIB_PATH@,$(LIBDIR)/qubes-gui-daemon/shmoverride.so," < $< > $@
+
 clean:
-	rm -f ./*~ ./*.o shmoverride.so X-wrapper-qubes
+	rm -f ./*~ ./*.o shmoverride.so X-wrapper-qubes Xwayland-wrapper
 
 %.o: %.c Makefile
 	$(CC) -MD -MP -MF $@.dep -c -o $@ $(extra_cflags) $(CFLAGS) $<

=== window-icon-updater/Makefile ===
--- 
+++ 
@@ -3,6 +3,7 @@
 
 install:
 	install -D icon-receiver $(DESTDIR)/usr/lib/qubes/icon-receiver
+	install -d $(DESTDIR)/etc/qubes-rpc
 	ln -s /var/run/qubes/icon-receiver.sock $(DESTDIR)/etc/qubes-rpc/qubes.WindowIconUpdater
 	install -d $(DESTDIR)/etc/qubes/rpc-config
 	install -m 0664 -D qubes.WindowIconUpdater.config $(DESTDIR)/etc/qubes/rpc-config/qubes.WindowIconUpdater

=== debian/changelog ===
qubes-gui-daemon (4.3.13-1+deb13u1) trixie; urgency=medium

  * Build for trixie

 -- Builder <user@localhost>  Thu, 18 Sep 2025 04:53:04 +0200

qubes-gui-daemon (4.3.13-1) unstable; urgency=medium

  [ Ali Mirjamali ]
  * Initialize asyncio event loop before using it

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 18 Sep 2025 04:53:04 +0200

=== debian/control ===
--- 
+++ 
@@ -35,6 +35,7 @@
  qubes-core-qrexec (>= 4.1.5),
  python3-qubesimgconverter (>= 4.1.4),
  socat,
+ ${daemon:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
 Recommends:

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DESTDIR=$(shell pwd)/debian/tmp
export LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

DIST := $(shell grep ^VERSION_CODENAME= /etc/os-release | cut -d = -f 2)


%:
	dh $@ --with config-package

override_dh_auto_build:
	make all

override_dh_auto_install:
	dh_auto_install
	mv $(DESTDIR)/usr/bin/X-wrapper-qubes $(DESTDIR)/usr/bin/X.qubes

override_dh_install:
	dh_install --fail-missing

override_db_gencontrol:
	if [ "$(DIST)" != "bookworm" ] && [ "$(DIST)" != "jammy" ] && [ "$(DIST)" != "noble" ]; then \
		echo "daemon:Depends=qubes-notification-daemon" >> debian/qubes-gui-daemon.substvars; \
	fi
	dh_gencontrol


# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- #	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

## qubes-gui-daemon 4.3.14

=== debian/changelog ===
qubes-gui-daemon (4.3.14-1+deb13u1) trixie; urgency=medium

  * Build for trixie

 -- Builder <user@localhost>  Mon, 20 Oct 2025 22:40:45 +0200

qubes-gui-daemon (4.3.14-1) unstable; urgency=medium

  [ Aaron Rainbolt ]
  * Don't event-buffer ConfigureNotify, MapNotify, and ReparentNotify
    events

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 20 Oct 2025 22:40:45 +0200

## qubes-gui-daemon 4.3.15

=== debian/changelog ===
qubes-gui-daemon (4.3.15-1+noble1) noble; urgency=medium

  * Build for noble

 -- Builder <user@localhost>  Wed, 07 Jan 2026 17:06:30 +0100

qubes-gui-daemon (4.3.15-1) unstable; urgency=medium

  * Re-dock tray icons when tray manager is restarted

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 07 Jan 2026 17:06:30 +0100
